#include <Wire.h>

bool connection78 = false;
bool connection49 = false;
bool connection510 = false;
bool connection611 = false;
bool printed = false;

char s1[5] = { 49, 56, 54, 48, 0 };
char s2[5] = { 49, 52, 57, 56, 0 };
char s3[5] = { 49, 56, 54, 57, 0 };
char s4[5] = { 49, 57, 54, 48, 0 };
char s5[] = "You found all the points on the world map, wait to reveal a message to humanity:";
char s6[102]  = { 84, 104, 101, 32, 109, 97, 105, 110, 32, 99, 97, 117,          \
                  115, 101, 32, 111, 102, 32, 116, 104, 101, 32, 109, 111, 115,  \
                  116, 32, 118, 105, 111, 108, 101, 110, 116, 32, 99, 114,       \
                  105, 109, 101, 115, 32, 105, 115, 32, 97, 108, 119, 97, 121,   \
                  115, 32, 97, 32, 98, 101, 108, 105, 101, 102, 32, 116, 104,     \
                  97, 116, 32, 115, 111, 109, 101, 32, 112, 101, 111, 112, 108,  \
                  101, 32, 97, 114, 101, 32, 98, 101, 116, 116, 101, 114,        \
                  32, 116, 104, 97, 110, 32, 111, 116, 104, 101, 114, 115, 46, 0 };

void setup() { 
  Serial.begin( 9600 );
  pinMode( 2, OUTPUT );
  pinMode( 3, OUTPUT );
  pinMode( 12, OUTPUT );
  pinMode( 13, OUTPUT );
  for ( int i=0; i<4; i++ )
    digitalWrite( i, LOW );  
} 

bool checkConnection( int a, int b ) {
  bool b1, b2, b3, b4;
  int x;
  pinMode( a, OUTPUT );
  pinMode( b, INPUT_PULLUP );
  digitalWrite( a, LOW );
  x = digitalRead( b );
  b1 = ( x == LOW );
  digitalWrite( a, HIGH );
  x = digitalRead( b );
  b2 = ( x == HIGH );
  digitalWrite( a, LOW );
  x = digitalRead( b );
  b3 = ( x == LOW );
  digitalWrite( a, HIGH );
  x = digitalRead( b );
  b4 = ( x == HIGH );
  return b1 && b2 && b3 && b4;
}


void loop() {
  if ( !printed ) {
    if ( !checkConnection( 4, 9 ) && !checkConnection( 5, 10 ) && !checkConnection( 6, 11 ) && !connection78 && checkConnection( 7, 8 )) {
      connection78 = true;
      digitalWrite( 2, HIGH );
      Serial.println( s1 );
    }
    if ( !connection49 && !checkConnection( 5, 10 ) && !checkConnection( 6, 11 ) && checkConnection( 4, 9 ) && checkConnection( 7, 8 ))  {
      connection49 = true;
      digitalWrite( 3, HIGH );
      Serial.println( s2 );
    }
    if ( !checkConnection( 6, 11 ) && !connection510  && checkConnection( 5, 10 ) && checkConnection( 7, 8 ) && checkConnection( 4, 9 )) {
      connection510 = true;
      digitalWrite( 12, HIGH );
      Serial.println( s3 );
    }
    if ( !connection611 && checkConnection( 6, 11 ) && checkConnection( 7, 8 ) && checkConnection( 4, 9 ) && checkConnection( 5, 10 ) && connection510 ) {
      connection611 = true;
      digitalWrite( 13, HIGH );
      Serial.println( s4 );
    }
    if ( connection78 && connection49 && connection510 && connection611 && !printed ) {
        Serial.println( s5 );
        Serial.println();
        delay( 1000 );
        for ( int i=0; i<5; i++ ){
          digitalWrite( 2, LOW );
          digitalWrite( 3, LOW );
          digitalWrite( 12, LOW );
          digitalWrite( 13, LOW );
          delay(500);
          digitalWrite( 2, HIGH );
          digitalWrite( 3, HIGH );
          digitalWrite( 12, HIGH );
          digitalWrite( 13, HIGH );
        }
        delay( 2000 );
        for ( int i=0; i < strlen( s6 ); i++ ) {
          Serial.print( s6[i] );
          delay( 1000 ); 
        }
        Serial.println();
        Serial.println();
        Serial.println("Congratulations!");
        printed = true;
    }
  }
  delay(200);  
}
